/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

import { SParser } from "./SParser";
import { TopologyData } from "../types/TopologyData";
import { MarkerTopo } from "../types/topology/MarkerTopo";
import { Node } from "../types/topology/Node";
import { Relation } from "../types/topology/Relation";

/**
 * 拓扑图信息解析器
 *
 * @author 郝建龙 <haojianlong@sagacloud.cn>
 */
export class STopologyParser extends SParser {
    /** 节点 list */
    nodeList = [];
    /** 标记 list */
    markList = [];
    /** 关系 list */
    relationList = [];

    /**
     * 解析数据
     *
     * @param data  楼层数据
     */
    parseData(data: TopologyData): void {
        if (data.Marks) {
            data.Marks.forEach((t: MarkerTopo): void => {
                this.addMarks(t);
            });
        }

        if (data.Nodes) {
            data.Nodes.forEach((t: Node): void => {
                this.addNodes(t);
            });
        }

        if (data.Relations) {
            data.Relations.forEach((t: Relation): void => {
                this.addRelations(t);
            });
        }
    }

    /**
     * 添加标识对象
     */
    private addMarks(t: MarkerTopo): void {}

    /**
     * 添加关系对象
     */
    private addRelations(t: Relation): void {}

    /**
     * 添加节点对象
     */
    private addNodes(t: Node): void {}
}
